SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Magnitude subclass: #Measure
	instanceVariableNames: 'unit amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'instance creation' stamp: 'achavez 5/26/2013 22:51'!
amount: aNumber unit: aUnit
	(aUnit convert: aNumber to: aUnit baseUnit) amount = 0 ifTrue: [ ^NullMeasure unit: aUnit ].
	^self new amount: aNumber unit: aUnit! !

!Measure methodsFor: 'arithmetic' stamp: 'achavez 5/27/2013 11:08'!
* aMeasure
	^Measure amount: self amount * aMeasure amount unit: aMeasure unit * unit! !

!Measure methodsFor: 'arithmetic' stamp: 'achavez 5/25/2013 17:58'!
+ aMeasure 
	|converted|
	converted := aMeasure convertTo: unit.
	^Measure amount: amount + converted amount unit: unit! !

!Measure methodsFor: 'arithmetic' stamp: 'achavez 5/13/2013 21:32'!
-aDistance 
	^self  + aDistance negated! !

!Measure methodsFor: 'arithmetic' stamp: 'MatiasSalegas 5/27/2013 01:58'!
/ aMeasure 
	^self * aMeasure reciprocal! !

!Measure methodsFor: 'comparing' stamp: 'achavez 5/15/2013 21:36'!
< aDistance 
	|converted| 
	converted := aDistance convertTo: unit.
	^amount < converted amount.! !

!Measure methodsFor: 'comparing' stamp: 'achavez 5/26/2013 23:41'!
= aMeasure
	|converted otherConverted|
	^(self class = aMeasure class or: [aMeasure isKindOf: Number]) and: 
	[
		converted := unit convertToBaseUnit: amount.
		otherConverted := aMeasure unit convertToBaseUnit: aMeasure amount. 
		unit baseUnit = aMeasure unit baseUnit and: [converted amount = otherConverted amount]
	].
	
			! !

!Measure methodsFor: 'accessing' stamp: 'achavez 5/8/2013 20:24'!
amount
	^amount! !

!Measure methodsFor: 'creation' stamp: 'achavez 5/8/2013 20:23'!
amount: aNumber unit: aUnit
	amount := aNumber.
	unit := aUnit! !

!Measure methodsFor: 'services' stamp: 'achavez 5/22/2013 19:44'!
convertTo: aUnit 
	|value|
	value := unit convert: amount to: aUnit.
	^ Measure amount: value unit: aUnit! !

!Measure methodsFor: 'comparing' stamp: 'achavez 5/25/2013 19:00'!
hash 
	^ unit baseUnit hash bitXor: (self convertTo: unit baseUnit) amount hash
! !

!Measure methodsFor: 'arithmetic' stamp: 'achavez 5/20/2013 20:39'!
negated
	^Measure amount: amount negated unit: unit.! !

!Measure methodsFor: 'printing' stamp: 'achavez 5/8/2013 20:24'!
printOn: aStream 

	aStream nextPutAll: amount asString, ' '.
	unit printOn: aStream.
	amount > 1 ifTrue: [ aStream nextPut: $s ]! !

!Measure methodsFor: 'arithmetic' stamp: 'MatiasSalegas 5/27/2013 02:00'!
reciprocal

	^Measure amount: (self convertTo: unit baseUnit) amount reciprocal unit: unit baseUnit reciprocal! !

!Measure methodsFor: 'creation' stamp: 'achavez 5/20/2013 20:39'!
to: stop 
	|step|
	step := Measure amount: 1 unit: unit.
	^self to: stop by: step.! !

!Measure methodsFor: 'creation' stamp: 'achavez 5/25/2013 18:41'!
to: stop by: step 
	
	^MeasureInterval from: self to: stop by: step.! !

!Measure methodsFor: 'accessing' stamp: 'achavez 5/8/2013 20:25'!
unit
	^unit! !

Measure subclass: #NullMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NullMeasure class methodsFor: 'instance creation' stamp: 'achavez 5/26/2013 22:45'!
unit: aUnit
	^self new amount: 0 unit: aUnit! !

!NullMeasure methodsFor: 'comparing' stamp: 'achavez 5/26/2013 22:48'!
= aMeasure 
	^(aMeasure unit convert: aMeasure amount to: aMeasure unit baseUnit) amount = 0
	! !

!Number methodsFor: '*EjerciciosPoo-Measure' stamp: 'achavez 5/25/2013 01:37'!
amount 
	^self ! !

!Number methodsFor: '*EjerciciosPoo-Measure' stamp: 'achavez 5/25/2013 01:30'!
unit
	^NullUnit new! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'achave 5/24/2013 19:20'!
canNotConvertMeasurementException
	
	^Error! !

!MeasureTest methodsFor: 'temperature units' stamp: 'achavez 5/22/2013 19:07'!
celsius
	
	^NonProportionalDerivedUnit celsius! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
centimeter
	
	^ProportionalDerivedUnit centimeter! !

!MeasureTest methodsFor: 'time units' stamp: 'achavez 5/24/2013 18:17'!
day
	
	^ProportionalDerivedUnit day! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
decameter
	
	^ProportionalDerivedUnit decameter! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
decimeter
	
	^ProportionalDerivedUnit decimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/20/2013 20:35'!
distanceExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/20/2013 20:36'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 13:18'!
eightCubicMeters

		^Measure amount: 8 unit: self meter * self meter * self meter ! !

!MeasureTest methodsFor: 'temperature units' stamp: 'achavez 5/22/2013 19:07'!
fahrenheit
	
	^NonProportionalDerivedUnit fahrenheit! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 18:24'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod
	^initialSpeed + (anAcceleration * aTimePeriod)
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 13:17'!
fourSquaredMeters

	^Measure amount: 4 unit: self meter * self meter ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 17:44'!
halfMeterBySecond
	^Measure amount: 1/2 unit: self meter / self second! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
hectometer
	
	^ProportionalDerivedUnit hectometer! !

!MeasureTest methodsFor: 'time units' stamp: 'achavez 5/24/2013 18:18'!
hour
	
	^ProportionalDerivedUnit hour! !

!MeasureTest methodsFor: 'temperature units' stamp: 'achavez 5/22/2013 20:11'!
kelvin
	
	^BaseUnit kelvin! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
kilometer
	
	^ProportionalDerivedUnit kilometer! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 20:10'!
meter

	^BaseUnit meter! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
millimeter
	
	^ProportionalDerivedUnit millimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
minusOneMeter 

	^Measure amount: 1 negated unit: self meter! !

!MeasureTest methodsFor: 'time units' stamp: 'achavez 5/22/2013 20:16'!
minute
	
	^ProportionalDerivedUnit minute! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'achavez 5/22/2013 20:11'!
oneCelsius
	
	^Measure amount: 1 unit: self celsius! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
oneCentimeter
	
	^Measure amount: 1 unit: self centimeter! !

!MeasureTest methodsFor: 'time measures' stamp: 'achave 5/24/2013 19:17'!
oneDay
	
	^Measure amount: 1 unit: self day! !

!MeasureTest methodsFor: 'time measures' stamp: 'achave 5/24/2013 19:16'!
oneHour
	
	^Measure amount: 1 unit: self hour! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
oneHundredCentimeters

	^Measure amount: 100 unit: self centimeter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 18:24'!
oneHundredTwentyOneMetersPerSecond

	^Measure amount: 121 unit: self meter / self second! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
oneMeter
	
	^Measure amount: 1 unit: self meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 17:45'!
oneMeterPerSecond

	^Measure amount: 1 unit: self meter / self second! !

!MeasureTest methodsFor: 'time measures' stamp: 'achavez 5/22/2013 20:13'!
oneMinute
	
	^Measure amount: 1 unit: self minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'achavez 5/22/2013 20:13'!
oneSecond

	^Measure amount: 1 unit: self second! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 13:19'!
oneSquaredMeter

	^Measure amount: 1 unit: self meter * self meter ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 13:19'!
oneSquaredSecond

	^Measure amount: 1 unit: self second * self second ! !

!MeasureTest methodsFor: 'time units' stamp: 'achavez 5/22/2013 20:16'!
second
	
	^BaseUnit second! !

!MeasureTest methodsFor: 'time measures' stamp: 'achave 5/24/2013 19:17'!
sixtyMinutes
	
	^Measure amount: 60 unit: self minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'achave 5/24/2013 19:34'!
sixtyOneSeconds
	
	^Measure amount: 61 unit: self second! !

!MeasureTest methodsFor: 'time measures' stamp: 'achavez 5/22/2013 20:12'!
sixtySeconds
	
	^Measure amount: 60 unit: self second! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'achavez 5/22/2013 20:42'!
test01ObjectsRepresentingSameMeasureShouldBeEqual
	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'achavez 5/24/2013 18:16'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'achavez 5/24/2013 18:20'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'achavez 5/25/2013 16:40'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'achavez 5/25/2013 17:13'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'achavez 5/25/2013 17:44'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self halfMeterBySecond
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'achavez 5/22/2013 20:11'!
thirtyTwoFahrenheits
	
	^Measure amount: 32 unit: self fahrenheit ! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'achave 5/24/2013 19:18'!
twentyFourHours
	
	^Measure amount: 24 unit: self hour! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'achave 5/24/2013 19:34'!
twoCelsius
	
	^Measure amount: 2 unit: self celsius! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
twoHundredCentimeters
	
	^Measure amount: 200 unit: self centimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
twoMeters
	
	^Measure amount: 2 unit: self meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 17:42'!
twoMetersBySecond

	^Measure amount: 2 unit: self meter / self second ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 17:45'!
twoMetersPerSquaredSecond

	^Measure amount: 2 unit: self meter / (self second * self second)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'achavez 5/25/2013 13:16'!
twoMetersTimesSecond
	^Measure amount: 2 unit: self meter * self second 
! !

!MeasureTest methodsFor: 'time measures' stamp: 'achave 5/24/2013 19:32'!
twoSeconds
	
	^Measure amount: 2 unit: self second! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'achavez 5/22/2013 20:11'!
zeroCelsius
	
	^Measure amount: 0 unit: self celsius! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'achavez 5/25/2013 18:36'!
zeroKelvin
	
	^Measure amount: 0 unit: self kelvin! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
zeroMeters

	^Measure amount: 0 unit: self meter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'achave 5/24/2013 19:35'!
zeroSeconds
	
	^Measure amount: 0 unit: self second! !

Object subclass: #MeasureInterval
	instanceVariableNames: 'start step stop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval class methodsFor: 'instance creation' stamp: 'achavez 5/25/2013 18:42'!
from: startMeasure to: stopMeasure by: stepMeasure 
	^self new
		setFrom: startMeasure
		to: stopMeasure
		by: stepMeasure! !

!MeasureInterval methodsFor: 'enumeration' stamp: 'achavez 5/25/2013 18:44'!
do: aBlock 
	| aValue index size |
	index := 0.
	size := self size.
	[index < size]
		whileTrue: [aValue := start + (step * index).
			index := index + 1.
			aBlock value: aValue]! !

!MeasureInterval methodsFor: 'accessing' stamp: 'achavez 5/25/2013 18:45'!
first
	^start! !

!MeasureInterval methodsFor: 'accessing' stamp: 'achavez 5/25/2013 18:48'!
increment
	^step! !

!MeasureInterval methodsFor: 'accessing' stamp: 'achavez 5/25/2013 18:47'!
last
	^stop! !

!MeasureInterval methodsFor: 'creation' stamp: 'achavez 5/25/2013 18:43'!
setFrom: startMeasure to: stopMeasure by: stepMeasure
	start := startMeasure.
	stop := stopMeasure.
	step := stepMeasure! !

!MeasureInterval methodsFor: 'accessing' stamp: 'achavez 5/25/2013 18:44'!
size 
	| stopConverted difference |
	stopConverted := stop convertTo: step unit.
	difference := (stopConverted - start)/step amount.
	^difference amount + 1
! !

Object subclass: #Unit
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Unit subclass: #BaseUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!BaseUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 19:39'!
kelvin
	^self new name: 'kelvin'! !

!BaseUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 19:08'!
meter 
	^self new name: 'meter'! !

!BaseUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 19:40'!
second 
	^self new name: 'second'! !

!BaseUnit methodsFor: 'comparing' stamp: 'achavez 5/24/2013 18:40'!
= aUnit
	^self class = aUnit class and: [ name = aUnit name ]! !

!BaseUnit methodsFor: 'services' stamp: 'achavez 5/25/2013 17:33'!
baseUnit
	^self! !

!BaseUnit methodsFor: 'error' stamp: 'achave 5/24/2013 19:28'!
canNotConvertFrom: aUnit to: anotherUnit 
	self error: 'Cannot convert from ', aUnit printString, ' to ', anotherUnit printString.! !

!BaseUnit methodsFor: 'services' stamp: 'achavez 5/22/2013 20:34'!
convertFromBaseUnit: aNumber
	^aNumber! !

!BaseUnit methodsFor: 'services' stamp: 'achavez 5/22/2013 20:34'!
convertToBaseUnit: aNumber
	^aNumber! !

!BaseUnit methodsFor: 'comparing' stamp: 'achavez 5/22/2013 21:16'!
hash 	
	^self class hash bitXor: name hash! !

!BaseUnit methodsFor: 'creation' stamp: 'achavez 5/26/2013 23:01'!
name: aString
	name := aString.
! !

BaseUnit subclass: #NullUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NullUnit methodsFor: 'arithmetic' stamp: 'achavez 5/25/2013 17:16'!
* aUnit 
	^aUnit! !

!NullUnit methodsFor: 'arithmetic' stamp: 'achavez 5/25/2013 17:16'!
/ aUnit
	^aUnit! !

!NullUnit methodsFor: 'private' stamp: 'achavez 5/25/2013 13:37'!
divisionForUnit: aUnit 
	^aUnit! !

!NullUnit methodsFor: 'accessing' stamp: 'MatiasSalegas 5/27/2013 02:23'!
factors

	^Dictionary new! !

!NullUnit methodsFor: 'creation' stamp: 'achavez 5/25/2013 01:34'!
initialize 
	name := 'null'! !

!NullUnit methodsFor: 'accessing' stamp: 'achavez 5/26/2013 18:40'!
isZero
	^false! !

!NullUnit methodsFor: 'private' stamp: 'achavez 5/25/2013 13:08'!
productForUnit: aUnit 
	^aUnit! !

!NullUnit methodsFor: 'arithmetic' stamp: 'MatiasSalegas 5/27/2013 02:01'!
reciprocal

	^self! !

Unit subclass: #CompoundUnit
	instanceVariableNames: 'factors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundUnit class methodsFor: 'instance creation' stamp: 'achavez 5/27/2013 10:30'!
reciprocalUnit: aUnit
	^self new reciprocalUnit: aUnit! !

!CompoundUnit class methodsFor: 'instance creation' stamp: 'achavez 5/25/2013 15:29'!
unit: aUnit times: anotherUnit
	^self new unit: aUnit times: anotherUnit! !

!CompoundUnit methodsFor: 'comparing' stamp: 'achavez 5/25/2013 17:13'!
= aUnit
	^self baseUnit factors = aUnit baseUnit factors! !

!CompoundUnit methodsFor: 'creation' stamp: 'achavez 5/25/2013 17:57'!
add: aUnit
	aUnit addTo: factors.
	
! !

!CompoundUnit methodsFor: 'creation' stamp: 'achavez 5/25/2013 18:17'!
addTo: aDictionary
	factors keysAndValuesDo: [:key :value | aDictionary at: key put: (aDictionary at: key ifAbsent: 0) + value]! !

!CompoundUnit methodsFor: 'accessing' stamp: 'MatiasSalegas 5/27/2013 02:27'!
baseUnit
	
	^self! !

!CompoundUnit methodsFor: 'services' stamp: 'MatiasSalegas 5/27/2013 03:03'!
convertFromBaseUnit: aNumber
	^aNumber ! !

!CompoundUnit methodsFor: 'services' stamp: 'MatiasSalegas 5/27/2013 03:04'!
convertToBaseUnit: aNumber

	^aNumber ! !

!CompoundUnit methodsFor: 'accessing' stamp: 'achavez 5/25/2013 16:47'!
factors
	^factors! !

!CompoundUnit methodsFor: 'comparing' stamp: 'achavez 5/25/2013 19:01'!
hash
	^self baseUnit factors hash! !

!CompoundUnit methodsFor: 'creation' stamp: 'achavez 5/27/2013 10:31'!
reciprocalUnit: aUnit
	factors := Dictionary new.
	name := '1/', aUnit name.
	self substract: aUnit.
! !

!CompoundUnit methodsFor: 'creation' stamp: 'achavez 5/26/2013 23:09'!
substract: aUnit
	aUnit substractFrom: factors.
! !

!CompoundUnit methodsFor: 'creation' stamp: 'achavez 5/26/2013 23:09'!
substractFrom: aDictionary
	factors keysAndValuesDo: [:key :value | aDictionary at: key put: (aDictionary at: key ifAbsent: 0) - value]
! !

!CompoundUnit methodsFor: 'creation' stamp: 'achavez 5/27/2013 11:16'!
unit: aUnit times: anotherUnit
	factors := Dictionary new.
	name := aUnit name, '*', anotherUnit name.
	self add: aUnit; add: anotherUnit.
	factors := factors select: [ :each | each ~= 0].
	factors size = 0 ifTrue: [ ^NullUnit new ].
! !

Unit subclass: #DerivedUnit
	instanceVariableNames: 'baseUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DerivedUnit methodsFor: 'services' stamp: 'achavez 5/25/2013 16:26'!
baseUnit
	^baseUnit! !

DerivedUnit subclass: #NonProportionalDerivedUnit
	instanceVariableNames: 'fromBlock toBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NonProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 21:40'!
celsius
	^self new name: 'celsius' baseUnit: BaseUnit kelvin fromBaseUnit: [ :n | n - (27315/100) ] toBaseUnit: [ :n | n + (27315/100) ]! !

!NonProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 21:49'!
fahrenheit
	^self new name: 'fahrenheit' baseUnit: BaseUnit kelvin fromBaseUnit: [ :n | (9/5) * n - (45967/100)] toBaseUnit: [ :n | n + (45967/100) * (5/9) ]! !

!NonProportionalDerivedUnit methodsFor: 'services' stamp: 'achavez 5/22/2013 20:04'!
convertFromBaseUnit: aNumber
	^fromBlock value: aNumber! !

!NonProportionalDerivedUnit methodsFor: 'services' stamp: 'achavez 5/22/2013 20:04'!
convertToBaseUnit: aNumber
	^toBlock value: aNumber! !

!NonProportionalDerivedUnit methodsFor: 'accessing' stamp: 'achavez 5/22/2013 20:02'!
fromBlock
	^fromBlock! !

!NonProportionalDerivedUnit methodsFor: 'creation' stamp: 'achavez 5/22/2013 19:57'!
name: aName baseUnit: aUnit fromBaseUnit: aBlock toBaseUnit: anotherBlock
	name := aName.
	baseUnit := aUnit.
	fromBlock := aBlock.
	toBlock := anotherBlock! !

!NonProportionalDerivedUnit methodsFor: 'accessing' stamp: 'achavez 5/22/2013 20:02'!
toBlock
	^toBlock! !

DerivedUnit subclass: #ProportionalDerivedUnit
	instanceVariableNames: 'factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
centimeter
	^self new name: 'centimeter' baseUnit: BaseUnit meter factor: 1/100! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/24/2013 18:19'!
day
	^self new name: 'day' baseUnit: BaseUnit second factor: 60*60*24! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
decameter
	^self new name: 'decameter' baseUnit: BaseUnit meter factor: 10! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
decimeter
	^self new name: 'decimeter' baseUnit: BaseUnit meter factor: 1/10! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
hectometer
	^self new name: 'hectometer' baseUnit: BaseUnit meter factor: 100! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/24/2013 18:19'!
hour
	^self new name: 'hour' baseUnit: BaseUnit second factor: 60*60! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
kilometer
	^self new name: 'kilometer' baseUnit: BaseUnit meter factor: 1000! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:45'!
millimeter
	^self new name: 'millimeter' baseUnit: BaseUnit meter factor: 1/1000! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:48'!
minute
	^self new name: 'minute' baseUnit: BaseUnit second factor: 60! !

!ProportionalDerivedUnit methodsFor: 'services' stamp: 'achavez 5/22/2013 20:06'!
convertFromBaseUnit: aNumber
	^aNumber / factor! !

!ProportionalDerivedUnit methodsFor: 'services' stamp: 'achavez 5/22/2013 20:05'!
convertToBaseUnit: aNumber
	^aNumber * factor! !

!ProportionalDerivedUnit methodsFor: 'accessing' stamp: 'achavez 5/22/2013 19:11'!
factor
	^factor! !

!ProportionalDerivedUnit methodsFor: 'creation' stamp: 'achavez 5/22/2013 19:54'!
name: aString baseUnit: aUnit factor: aNumber
	name := aString.
	baseUnit := aUnit.
	factor := aNumber
	! !

!Unit methodsFor: 'arithmetic' stamp: 'achavez 5/25/2013 13:09'!
* aUnit 
	^aUnit productForUnit: self! !

!Unit methodsFor: 'arithmetic' stamp: 'MatiasSalegas 5/27/2013 03:00'!
/ aUnit 
	^self * aUnit reciprocal ! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/25/2013 17:30'!
= aUnit 
	^self class = aUnit class and: [ name = aUnit name and: [self baseUnit = aUnit baseUnit]]! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/25/2013 18:36'!
adaptToInteger: rcvr andSend: selector
	|measure|
	measure := Measure amount: 1 unit: self.
	^ measure perform: selector with: rcvr! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/25/2013 17:55'!
addTo: aDictionary
	aDictionary at: self put: (aDictionary at: self ifAbsent: 0)+1.! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/25/2013 16:24'!
baseUnit
	^self subclassResponsibility ! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 20:28'!
convert: anAmount fromBaseUnitTo: aUnit
	^aUnit convertFromBaseUnit: anAmount! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/25/2013 17:17'!
convert: aNumber to: aUnit
	| baseAmount |
	self baseUnit = aUnit baseUnit ifFalse: [ ^self canNotConvertFrom: self to: aUnit ].
	baseAmount := self convertToBaseUnit: aNumber.
	^self convert: baseAmount fromBaseUnitTo: aUnit. ! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 20:05'!
convertFromBaseUnit: aNumber
	^self subclassResponsibility! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 20:05'!
convertToBaseUnit: aNumber
	^self subclassResponsibility! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/25/2013 19:00'!
hash
	^self class hash bitXor: (name hash bitXor: self baseUnit hash)! !

!Unit methodsFor: 'class initialization' stamp: 'MatiasSalegas 5/27/2013 02:21'!
initialize 

	name := '1'! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 19:12'!
printOn: aStream 
	^aStream nextPutAll: name! !

!Unit methodsFor: 'private' stamp: 'achavez 5/25/2013 15:08'!
productForUnit: aUnit 
	^CompoundUnit unit: self times: aUnit ! !

!Unit methodsFor: 'creation' stamp: 'achavez 5/27/2013 10:29'!
reciprocal

	^CompoundUnit reciprocalUnit: self! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/26/2013 23:09'!
substractFrom: aDictionary
	aDictionary at: self put: (aDictionary at: self ifAbsent: 0)-1.! !
